<template>
    <div class="app-container">
        <el-tabs v-model="platform" @tab-click="handleQuery">
            <el-tab-pane v-for="dict in dict.type.app_platform_type" :label="dict.label" :name="dict.value"></el-tab-pane>
        </el-tabs>
        <el-row :gutter="10" class="mb8">
            <el-col :span="1.5">
                <el-button type="primary" plain icon="el-icon-plus" @click="handleAdd" v-hasPermi="['app:version:add']">新增</el-button>
            </el-col>
            <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
        </el-row>

        <Page uri="/mapi/app/version/list" :request-params="queryParams" ref="pagination">
            <el-table-column label="ID" align="center" prop="id" width="80" />
            <el-table-column label="版本编号" align="center" prop="version" width="150" />
            <el-table-column label="更新说明" align="center" prop="updateRemark" :show-overflow-tooltip="true" />
            <el-table-column label="是否强制更新" align="center" prop="isRequire" width="150">
                <template slot-scope="scope">
                    <dict-tag :options="dict.type.sys_yes_no" :value="scope.row.isRequire" />
                </template>
            </el-table-column>
            <el-table-column label="创建人" align="center" prop="createBy" />
            <el-table-column label="创建时间" align="center" prop="createTime" />
            <el-table-column label="修改人" align="center" prop="updateBy" />
            <el-table-column label="修改时间" align="center" prop="createTime" />
            <!--      <el-table-column label="安装包地址" align="center" prop="apkUrl" />-->
            <el-table-column label="操作" align="center" class-name="small-padding fixed-width" fixed="right" width="150">
                <template slot-scope="scope">
                    <el-button type="text" icon="el-icon-edit" @click="handleUpdate(scope.row)" v-hasPermi="['app:version:edit']">修改</el-button>
                    <el-button type="text" icon="el-icon-delete" @click="handleDelete(scope.row)" v-hasPermi="['app:version:remove']">删除</el-button>
                </template>
            </el-table-column>
        </Page>

        <!-- 添加或修改APP版本管理对话框 -->
        <el-dialog :title="title" :visible.sync="open" size="30%" append-to-body>
            <el-row :gutter="15">
                <el-form ref="form" :model="form" :rules="rules" label-width="120px">
                    <el-col :span="24">
                        <el-form-item label="平台" prop="platform">
                            <el-select v-model="form.platform" placeholder="请选择平台" disabled>
                                <el-option v-for="dict in dict.type.app_platform_type" :key="dict.value" :label="dict.label" :value="dict.value"></el-option>
                            </el-select>
                        </el-form-item>
                        <el-form-item label="版本编号" prop="version">
                            <el-input v-model="form.version" placeholder="请输入版本编号" prefix="V">
                                <template slot="prepend">V</template>
                            </el-input>
                        </el-form-item>
                        <el-form-item label="安装包地址" prop="apkUrl" v-if="platform == 'Android'">
                            <el-input v-model="form.apkUrl" placeholder="请输入安装包地址" prefix="https://">
                                <template slot="prepend">https://</template>
                            </el-input>
                        </el-form-item>
                        <el-form-item label="更新说明" prop="updateRemark">
                            <el-input v-model="form.updateRemark" type="textarea" placeholder="请输入内容" />
                        </el-form-item>
                        <el-form-item label="是否强制更新" prop="isRequire">
                            <el-radio-group v-model="form.isRequire">
                                <el-radio-button v-for="dict in dict.type.sys_yes_no" :key="dict.value" :label="dict.value">{{ dict.label }}</el-radio-button>
                            </el-radio-group>
                        </el-form-item>
                    </el-col>
                </el-form>
            </el-row>

            <div slot="footer" class="dialog-footer">
                <el-button type="primary" @click="submitForm" style="margin-left: 5%">提交</el-button>
                <el-button @click="cancel">取 消</el-button>
            </div>
        </el-dialog>
    </div>
</template>

<script>
import { listVersion, getVersion, delVersion, addVersion, updateVersion, updateVersionStatus } from '@/api/app/version'

export default {
    name: 'Version',
    dicts: ['sys_yes_no', 'app_platform_type'],
    data() {
        return {
            platform: 'Android',
            // 遮罩层
            loading: true,
            // 选中数组
            ids: [],
            // 非单个禁用
            single: true,
            // 非多个禁用
            multiple: true,
            // 显示搜索条件
            showSearch: true,
            // 总条数
            total: 0,
            // APP版本管理表格数据
            versionList: [],
            // 弹出层标题
            title: '',
            // 是否显示弹出层
            open: false,
            // 查询参数
            queryParams: {},
            // 表单参数
            form: {
                platform: 'Android',
                isRequire: 'N'
            },
            // 表单校验
            rules: {
                platform: [{ required: true, message: '平台不能为空', trigger: 'change' }],
                updateRemark: [{ required: true, message: '更新说明不能为空', trigger: 'blur' }],
                isRequire: [{ required: true, message: '是否强制更新不能为空', trigger: 'blur' }],
                version: [{ required: true, message: '版本编号不能为空', trigger: 'blur' }]
            }
        }
    },
    created() {
        this.getList()
    },
    methods: {
        /** 查询APP版本管理列表 */
        getList() {
            this.$nextTick(() => {
                this.$refs.pagination.handleSearch(true)
            })
        },
        // 取消按钮
        cancel() {
            this.open = false
            this.reset()
        },
        // 表单重置
        reset() {
            this.form = {
                id: null,
                platform: this.platform,
                apkUrl: null,
                updateRemark: null,
                isRequire: 'N',
                version: null,
                createById: null,
                createBy: null,
                createTime: null,
                updateById: null,
                updateBy: null,
                updateTime: null,
                remark: null
            }
            this.resetForm('form')
        },
        /** 搜索按钮操作 */
        handleQuery() {
            this.$nextTick(() => {
                this.$refs.pagination.handleSearch(true)
            })
        },
        /** 重置按钮操作 */
        resetQuery() {
            this.resetForm('queryForm')
            this.handleQuery()
        },
        // 多选框选中数据
        handleSelectionChange(selection) {
            this.ids = selection.map((item) => item.id)
            this.single = selection.length !== 1
            this.multiple = !selection.length
        },
        /** 新增按钮操作 */
        handleAdd() {
            this.reset()
            this.open = true
            this.title = '添加APP版本管理'
        },
        /** 修改按钮操作 */
        handleUpdate(row) {
            this.reset()
            const id = row.id || this.ids
            getVersion(id).then((response) => {
                this.form = response.data
                this.open = true
                this.title = '修改APP版本管理'
            })
        },
        /** 提交按钮 */
        submitForm() {
            this.$refs['form'].validate((valid) => {
                if (valid) {
                    if (this.form.id != null) {
                        updateVersion(this.form).then((response) => {
                            this.$modal.msgSuccess('修改成功')
                            this.open = false
                            this.getList()
                        })
                    } else {
                        addVersion(this.form).then((response) => {
                            this.$modal.msgSuccess('新增成功')
                            this.open = false
                            this.getList()
                        })
                    }
                }
            })
        },
        /** 删除按钮操作 */
        handleDelete(row) {
            const ids = row.id || this.ids
            this.$modal
                .confirm('是否确认删除APP版本管理编号为"' + ids + '"的数据项？')
                .then(function () {
                    return delVersion(ids)
                })
                .then(() => {
                    this.getList()
                    this.$modal.msgSuccess('删除成功')
                })
                .catch(() => {})
        },
        /** 导出按钮操作 */
        handleExport() {
            this.download(
                'app/version/export',
                {
                    ...this.queryParams
                },
                `version_${new Date().getTime()}.xlsx`
            )
        },
        checkClose(done) {
            this.$confirm('是否关闭表单，关闭后数据将丢失？')
                .then(function () {
                    done()
                })
                .then(() => {})
                .catch(() => {})
        }
    }
}
</script>

<style>
textarea {
    min-height: 100px;
}
</style>
